#
# "CALCS: Control all money fields to return zero if left blank.".
#
# Quick and dirty code converter. Since Innosphere wants us to avoid the use of the eval method
# we need to now convert those cases that we have no work around to the long form where the code is repeated
# for every box.
#
# OLD WAY THAT WAS USING EVAL:
#
# blue_dollar_list = %w{box2_39 box2_44}
# blue_dollar_list.each do |box| print box, eval("#{box}.replace('0')") if eval("#{box}").empty? end
#
# THIS TOOL WILL PRODUCE THE FOLLOWING CODE USING THE BOXES FROM THE ABOVE CODE:
#
# if (box2_39.strip.empty?)
# 	print 'box2_39', box2_39.replace('0')
# end
#
# if (box2_44.strip.empty?)
# 	print 'box2_44', box2_44.replace('0')
# end
#
# CURRENTLY USING 0, NOT 0.00 OR SOME OTHER VARIATION. THIS CAN BE IMPROVED ON IF NEED BE.
#
# HOW TO USE THIS TOOL:
#
# This routine reads FROM THE CLIPBOARD and copies code TO THE CLIPBOARD - Do the following:
#
# 1) Select and then COPY the ENTIRE code section that will need to be replaced. Keep that code selected because you
# will be able to paste right over it with the converted code. Just make sure that the only section in the code you
# are selecting for conversion has box references just in the array since this tool looks for boxes, it is not making
# sure they are in an array.
#
# ###############################################################
#
# Note [rtroy]:
# This algorithm can also blank all user entered monetary fields.
# Instead of copying the calculated fields, copy all of the boxes
# under:

# ***** Field Data *****
#box1_1 = 
#box1_2 =
#box1_3 =
#etc.

# Continue with step 2) below. Any box in the list that is
# not a monetary field or is a calc. that already defaults to
#zero will need to be deleted from the list.
#
# ###############################################################
#
# 2) From this file press F5 to execute this script. It automatically retrieves your copied code from the clipboard.
#
# 3) Check the output pane for code correctness. The ouput has ALSO been copied to the clipboard.
#
# 4) If the code is correct [i.e. it picked up the boxes correctly, you see the code, etc...] then
#	from the file that you are actually working on [where you copied from] do the following:
#
#	a) If you selected the ENTIRE code section then simply Ctrl-V to overwrite it with the new output.
#	b) If you dif NOT copy all the code, then select all of the old code and do a Ctrl-V to overwrite it.
#
# That is it....CHANGE NOTHING IN THIS FILE. Help is just a yell away.
#
require 'tk'

blueArray = TkClipboard.get(nil).scan(/box\d+_\d+/).uniq

codeStr = ""

blueArray.each do |box|

	codeStr += "if (#{box}.strip.empty?)\n\tprint '#{box}', #{box}.replace('0')\nend\n\n"
end

#
# TkClipboard.set first clears the clipboard.
#
TkClipboard.set(codeStr.empty? ? '' : codeStr, nil)

print codeStr
